'use strict';

var menhera = require('menhera');
var menheraUtils = require('menhera-utils');

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var matchColon = /\:/;
var matchAt = /\@/;
var index = {
  name: "Mue",
  _hooks: {
    data: menheraUtils.data,
    methods: menheraUtils.methods,
    Mue: {
      _: function _(_ref) {
        var _this2 = this;

        var _2 = _ref._,
            _val = _ref._val;
        var el = _val.el,
            data = _val.data,
            methods = _val.methods,
            directives = _val.directives;
        data && this._observe(data);
        methods && (this.$methods = methods);
        directives && menhera.$(directives, function (k, d) {
          _this2.$directives[k] = d.bind(_this2);
        });

        if (typeof window !== "undefined" && el) {
          this.$el = document.querySelector(el);

          this._compile(this.$el);

          this._runLifeCycle(_val);
        }
      }
    }
  },
  data: {
    $lifeCycle: ["beforeCreate", "created", "beforeMount", "mounted"],
    $el: {},
    $data: {},
    $methods: {},
    $directives: {},
    _binding: []
  },
  methods: {
    _runLifeCycle: function _runLifeCycle(_val) {
      var _this3 = this;

      var lc = this.$lifeCycle;
      menhera.$(lc, function (key, val) {
        var fn = _val[val];

        if (fn) {
          fn.bind(_this3)();
        }
      });
    },
    _updateWatch: function _updateWatch(watch) {
      var el = watch.el,
          attr = watch.attr,
          vm = watch.vm,
          exp = watch.exp;
      var val = vm.$data[exp] === undefined ? exp : vm.$data[exp];
      menhera.$set(el, _defineProperty({}, attr, val));
      return watch;
    },
    _addDirecitves: function _addDirecitves(key, watch) {
      if (!this._binding[key]) this._binding[key] = {
        _directives: []
      };

      this._binding[key]._directives.push(watch);
    },
    _observe: function _observe(data) {
      var _this4 = this;

      menhera.$(data, function (k, v) {
        if (Reflect.has(data, k)) _this4._binding[k] = {
          _directives: []
        };

        if (_typeof(v) === "object") {
          _this4._observe(v);
        }

        var binding = _this4._binding[k];
        var _this = _this4;
        Reflect.defineProperty(_this4.$data, k, {
          enumerable: true,
          configurable: true,
          get: function get() {
            return v;
          },
          set: function set(nV) {
            if (v !== nV) {
              v = nV;

              binding._directives.forEach(function (watch) {
                _this._updateWatch(watch);
              });
            }
          }
        });
      });
    },
    _compile: function _compile(root) {
      var _this5 = this;

      var nodes = root.children;
      menhera.$(nodes, function (k, n) {
        if (n.children.length) {
          _this5._compile(n);
        }
        menhera.$(_this5.$directives, function (k, d) {
          d({
            n: n
          });
        });
      });
    }
  },
  Mue: {
    directives: {
      on: function on(_ref2) {
        var _this6 = this;

        var n = _ref2.n;
        var attrs = n.getAttributeNames();
        attrs.forEach(function (attr) {
          var v_on = n.getAttribute(attr);

          if (matchAt.test(attr)) {
            attr = attr.replace(matchAt, "");
            n["on".concat(attr)] = _this6.$methods[v_on].bind(_this6.$data);
          }
        });
      },
      model: function model(_ref3) {
        var _this7 = this;

        var n = _ref3.n;
        var v_model = n.getAttribute("v-model");

        if (v_model && (n.tagName == "INPUT" || n.tagName == "TEXTAREA")) {
          this._binding[v_model]._directives.push(this._updateWatch({
            name: "input",
            el: n,
            vm: this,
            exp: v_model,
            attr: "value"
          }));

          n.addEventListener("input", function (key) {
            _this7.$data[v_model] = n.value;
          });
        }
      },
      bind: function bind(_ref4) {
        var _this8 = this;

        var n = _ref4.n;
        var attrs = n.getAttributeNames();
        attrs.forEach(function (attr) {
          var v_bind = n.getAttribute(attr);

          if (matchColon.test(attr)) {
            attr = attr.replace(matchColon, "");

            if (attr === "val" || attr === "value") {
              attr = "innerHTML";
            }

            _this8._addDirecitves(v_bind, _this8._updateWatch({
              name: "text",
              el: n,
              vm: _this8,
              exp: v_bind,
              attr: attr
            }));
          }
        });
        var v_bind = n.getAttribute("v-bind");

        if (v_bind) {
          this._addDirecitves(v_bind, this._updateWatch({
            name: "text",
            el: n,
            vm: this,
            exp: v_bind,
            attr: "innerHTML"
          }));
        }
      }
    }
  }
};

module.exports = index;
